#include <bits/stdc++.h>
#define rep(i,a,b) for (int i=a; i<b; i++)
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#define debug //
using namespace std;
typedef pair <int, int> PII;
typedef vector <int> VI;
typedef long long ll;
typedef long double ld;

void manacher (string &s, vector <int> &r) {
	int n = (int)s.size();
	r.clear(); r.resize(n, 1);
	int p = 0;
	while (p<n) {
		while (r[p]<=p && r[p]+p<n && s[p-r[p]]==s[p+r[p]]) r[p]++;
		if (r[p]==1) p++;
		else rep(d,1,r[p])
		{
			r[p+d] = min(r[p-d], r[p]-d);
			if (r[p+d]==r[p]-d) {
				p+=d;
				break;
			}
		}
	}
	rep(i,0,n) r[i]--;
}

int main ()
{
	//ios_base::sync_with_stdio(false);
	int n;
	string s;
	cin>>n >>s;
	
	vector <int> r1, r2;
	int res =n ;
	
	string t; //parzysty
	rep(i,0,n)
	{
		if (i>0) t.pb('#');
		t.pb(s[i]);
	}
	
	manacher(s, r1);
	manacher(t, r2);
	
	rep(i,0,n)
	{
		if (r1[i]+i==n-1) //palindrom dochodzi
		{
			res = min(res, i-r1[i]);
		}
	}
	
	rep(i,0,(int)r2.size()) if (i%2==1)
	{
		int r = (r2[i]+1)/2;
		if ((i/2)+r==n-1)
		{
			res = min(res, i/2-(r-1));
		}
	}
	printf ("%d\n", res);
}
