#include <bits/stdc++.h>
#define rep(i,a,b) for (int i=a; i<b; i++)
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#define mitte (lewy+prawy)/2
#define debug printf
using namespace std;
typedef pair <int, int> PII;
typedef vector <int> VI;
typedef long long ll;
typedef long double ld;

const int T = 1<<18;
const ll mod = 1e9+7;
int tree[T+T], A[T], n;
ll sum[T+T], lazy[T+T];

int gcdRead(int l, int r)
{
	l+=T;
	r+=T;
	int ret = tree[l];
	while (l<r)
	{
		if (l%2==1) ret = __gcd(ret, tree[l]);
		if (r%2==0) ret = __gcd(ret, tree[r]);
		l = (l+1)/2;
		r = (r-1)/2;
	}
	if (l==r) ret = __gcd(ret, tree[l]);
	return ret;
}

void up (int a, int lewy, int prawy)
{
	if (lazy[a]==-1LL) return;
	if (lewy<prawy)
	{
		lazy[a*2] = lazy[a];
		lazy[a*2+1] = lazy[a];
	}
	sum[a] = lazy[a] * ll(prawy - lewy+1) % mod;
	lazy[a] = -1LL;
}
void update (int a, int lewy, int prawy)
{
	if (lewy<prawy)
	{
		if (lazy[a]>=0LL) 
		{
			lazy[a*2] = lazy[a];
			lazy[a*2+1] = lazy[a];
		}
		up(a*2, lewy, mitte);
		up(a*2+1, mitte+1, prawy);
		
		lazy[a] = -1LL;
		sum[a] = sum[a*2]+sum[a*2+1] % mod;
	}
	else up(a, lewy, prawy);
}
void ustaw (int left, int right, ll x, int a=1, int lewy=0, int prawy = n-1)
{
	update(a, lewy, prawy);
	if (left<=lewy && right>=prawy) lazy[a] = x;
	else
	{
		if (left<=mitte) ustaw(left, right, x, a*2, lewy, mitte);
		if (right>mitte) ustaw(left, right, x, a*2+1, mitte+1, prawy);
	}
	update(a, lewy, prawy);
}
ll sumRead (int left, int right, int a=1, int lewy = 0, int prawy = n-1)
{
	update(a, lewy, prawy);
	if (left<=lewy && right>=prawy) return sum[a];
	else
	{
		ll ret = 0LL;
		if (left<=mitte) ret+=sumRead(left, right, a*2, lewy, mitte);
		if (right>mitte) ret+=sumRead(left, right, a*2+1, mitte+1, prawy);
		if (ret>=mod) ret-=mod;
		return ret;
	}
}


int main ()
{
	scanf ("%d", &n);
	rep(i,0,n) scanf ("%d", &A[i]);
	rep(i,0,n) tree[T+i] = A[i];
	
	for (int t = T-1; t>0; t--) tree[t] = __gcd(tree[t*2], tree[t*2+1]);
	
	ll res = 0LL;
	//ostatni mniejszy niz ja
	for (int pos=n-1; pos>=0; pos--)
	{
		int l = pos, r = n-1;
		while (l<r)
		{
			int mid = (l+r)/2;
			ll val = sumRead(mid+1, mid+1);
			if (val >= ll(A[pos])) r = mid;
			else l = mid+1;
		}
		ustaw(pos, l, A[pos]); //moje nowe maksimum
		
		ll g = A[pos];
		int left = pos, right = pos;
		while (left<n)
		{
			g = gcdRead(pos, left);
			l = right;
			r = n-1;
			while (l<r)
			{
				int mid = (l+r)/2;
				ll val = gcdRead(pos, mid+1);
				if (val < g) r = mid;
				else l = mid+1;
			}
			right = l;
			
			ll s = sumRead(left, right);
			ll d = g * s % mod;
			
			res+=d;
			res%=mod;
			
			right++;
			left = right;
		}
	}
	printf ("%lld\n" , res);
}
